unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  fpSpreadsheet, fpspreadsheetctrls, fpspreadsheetgrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    PanEd: TPanel;
    sCellIndicator1: TsCellIndicator;
    sCellIndicator2: TsCellEdit;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    WbkSrc1: TsWorkbookSource;
    WbkTabCtrl1: TsWorkbookTabControl;
    WshtGr1: TsWorksheetGrid;
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var aSh: TsWorksheet;
   rc,cc,aRSumTab, arsum: integer;
   svsumcell, BeitrBemGrCell, BeitrBemGr: string;
   Beitragsbemessungsgrenze, AVSatz, RVSatz, PDKVSATZ, PDPVSATZ: Double;
begin
  {$REGION 'this lines are ok' -fold}
  WbkSrc1.FileName:=''; //<-- leere Name erzeugt auch Workbook.  WbkSrc1.CreateNewWorkbook;
  aSh:=WbkSrc1.Workbook.AddWorksheet('testsh1');

  aSh.WriteText(1,1,'Scrolldown to line 53');
  aSh.WriteColWidth(0,3.71);
  aSh.WriteColWidth(1,2.8);
  aSh.WriteColWidth(2,2.8);
  aSh.WriteColWidth(3,6);
  aSh.WriteColWidth(4,6);
  aSh.WriteColWidth(5,6);
  aSh.WriteColWidth(6,6.8);
  aSh.WriteColWidth(7,7.86);
  aSh.WriteColWidth(8,8);
  aSh.WriteColWidth(9,6.8);

  PDKVSATZ:=7.3;
  PDPVSATZ:=0.6;
  Beitragsbemessungsgrenze:= 4987.5;
  AVSatz:= 1.3;
  RVSatz:= 9.3;
  aRSumTab:=43;
  arsum:=41;


  aSh.WriteText(aRSumTab+3,1,'Bearbeitet als Text eingefügte Formeln in Formeleditor oben, am Ende etwas hinzufügen und wieder löschen, Enter drücken,');
  aSh.WriteText(aRSumTab+4,1,'dann wird der Text in Formel umgewandelt und man sieht, dass die Formeln richtig sind.');
  aSh.WriteText(aRSumTab+5,1,'Fehler sind bei F53 und G53');
  WshtGr1.Col := 1;
  WshtGr1.Row := aRSumTab;


  rc:=aRSumTab+8; cc:=3;
  aSh.WriteNumber(arsum+2,8,5137);
  svsumcell:='E'+(rc+2).ToString;
  BeitrBemGrCell:='C'+(rc+2).ToString;
  BeitrBemGr:=Format('%.2f', [Beitragsbemessungsgrenze]);
  aSh.WriteNumber(rc+1,cc-1,Beitragsbemessungsgrenze); aSh.WriteFontSize(rc+1,cc-1,7);
  aSh.WriteText(rc,cc,'Sachbezüge'); aSh.WriteFontSize(rc,cc,7);
   aSh.WriteNumber(rc+1,cc,0); aSh.WriteFontSize(rc+1,cc+1,7);
  aSh.WriteText(rc,cc+1,'SV-Brutto'); aSh.WriteFontSize(rc,cc+1,7);
   aSh.WriteFormula(rc+1,cc+1,'=D'+(rc+2).ToString+'+I'+(arsum+3).ToString); //bei formel rc+1+1 weil excel mit 1 anfängt
  aSh.WriteText(rc,cc+2,'KV'); aSh.WriteFontSize(rc,cc+2,7);
  aSh.WriteText(rc,cc+3,'PV'); aSh.WriteFontSize(rc,cc+3,7);
  {$ENDREGION}
  // Die nächsten Zeilen verursachen Fehler, wenn man Sie als Formeln schreibt.
  // Einfach kommentare umschalten

  // Bei dem Kriegt man den Fehler: Unexpected charaecter in nummer:;.
  // aSh.WriteFormula(rc+1,cc+2,'=ROUND(((IF('+svsumcell+'>'+BeitrBemGr+';'+BeitrBemGr+';'+svsumcell+')*'+Format('%.2f', [PDKVSATZ])+')/100);2)');
  aSh.WriteText(rc+1,cc+2,'=ROUND(((IF('+svsumcell+'>'+BeitrBemGr+';'+BeitrBemGr+';'+svsumcell+')*'+Format('%.2f', [PDKVSATZ])+')/100);2)');

  // Hier ist der Fehler: Unknown identifier: C53;C53;E53.
  // Aber die Zellen gibt es:
  //aSh.WriteFormula(rc+1,cc+3,'=ROUND(((IF('+svsumcell+'>'+BeitrBemGrCell+';'+BeitrBemGrCell+';'+svsumcell+')*'+Format('%.2f', [PDPVSATZ])+')/100);2)');
  aSh.WriteText(rc+1,cc+3,'=ROUND(((IF('+svsumcell+'>'+BeitrBemGrCell+';'+BeitrBemGrCell+';'+svsumcell+')*'+Format('%.2f', [PDPVSATZ])+')/100);2)');
end;

end.

